
  IF(DEBUGCMAKE)
    MESSAGE ( STATUS "Processing java.cmake")
  ENDIF(DEBUGCMAKE)
if (NOT JAVA_CMAKE_DONE)
    MESSAGE ( STATUS "NOT JAVA_CMAKE_DONE")
if (APPLE)
    MESSAGE ( STATUS "APPLE")
	set (OSX true)
	if ("$ENV{JAVA_HOME}" STREQUAL "")
	    EXECUTE_PROCESS ( COMMAND "/usr/libexec/java_home"
                OUTPUT_VARIABLE JAVA_HOME
                ERROR_VARIABLE  JAVA_HOME_ERROR_OUTPUT
                RESULT_VARIABLE JAVA_HOME_RETURN_VALUE
		OUTPUT_STRIP_TRAILING_WHITESPACE)
	    set(ENV{JAVA_HOME} "${JAVA_HOME}")
	    IF(DEBUGCMAKE)
	        MESSAGE ( STATUS "Had to determine JAVA_HOME with /usr/libexec/java_home.")
	    ENDIF(DEBUGCMAKE)
	endif ("$ENV{JAVA_HOME}" STREQUAL "")
        # On MacOS X, it is always here now:
        #        set (JAVA_INCLUDE_PATH "/System/Library/Frameworks/JavaVM.framework/Headers/")
        # set ("$ENV{JAVA_INCLUDE_PATH}" "${JAVA_INCLUDE_PATH}")
	
	# Be sure that both JAVA_HOME and ENV{JAVA_HOME} are set
	if ("$ENV{JAVA_HOME}" STREQUAL "")
	    message(FATAL_ERROR "Don't have JAVA_HOME set.")
	else ("$ENV{JAVA_HOME}" STREQUAL "")
	    set(JAVA_HOME "$ENV{JAVA_HOME}")
	endif ("$ENV{JAVA_HOME}" STREQUAL "")
  IF(DEBUGCMAKE)
    MESSAGE ( STATUS "JAVA_HOME: ${JAVA_HOME} ENV{JAVA_HOME}: $ENV{JAVA_HOME}" )
    MESSAGE ( STATUS "JAVA_INCLUDE_PATH: ${JAVA_INCLUDE_PATH} ENV{JAVA_INCLUDE_PATH}: $ENV{JAVA_INCLUDE_PATH}" )
  ENDIF(DEBUGCMAKE)
endif (APPLE)

#Set up variables.  Override like:
# cmake -DJAVA_INCLUDE_PATH=/usr/lib/jvm/java-sun-6/include \
#   -DJAVA_INCLUDE_PATH2=/usr/lib/jvm/java-6-sun/inlclude/linux ..

SET(JAVA_HOME $ENV{JAVA_HOME})

if ( ANDROID OR APPLE OR UNIX )
  if ("$ENV{JAVA_HOME}" STREQUAL "")
      message(FATAL_ERROR "Don't have JAVA_HOME set.")
  endif ("$ENV{JAVA_HOME}" STREQUAL "")

  set (ENABLE_JAVA_SUPPORT true)
  set (DOJAVA_COMPILE true)
endif ( ANDROID OR APPLE OR UNIX )

IF ( ENABLE_JAVA_SUPPORT )
IF(DEBUGCMAKE)
    MESSAGE ( STATUS "Searching for Java..." )
ENDIF(DEBUGCMAKE)
    set (CMAKE_Java_COMPILER ${JAVA_HOME}/bin/javac)
    set (JAVA_COMPILER ${JAVA_HOME}/bin/javac)

    FIND_PACKAGE ( Java )
    set (CMAKE_Java_COMPILER ${JAVA_HOME}/bin/javac)
    set (JAVA_COMPILE ${JAVA_HOME}/bin/javac)
    set (JAVA_ARCHIVE ${JAVA_HOME}/bin/jar)
    set (JAVA_RUNTIME ${JAVA_HOME}/bin/java)
    set (JAVA_JAVA_H ${JAVA_HOME}/bin/javah)

    FIND_PACKAGE ( JNI )
    message("After trying to find JNI: ${JAVA_INCLUDE_PATH}")
    if("${JAVA_INCLUDE_PATH2}" STREQUAL "JAVA_INCLUDE_PATH2-NOTFOUND")
      message("Setting PATH2!!")
      set(JAVA_INCLUDE_PATH2 "${JAVA_INCLUDE_PATH}")
      message("${JAVA_INCLUDE_PATH2} ${JAVA_INCLUDE_PATH}")
    endif("${JAVA_INCLUDE_PATH2}" STREQUAL "JAVA_INCLUDE_PATH2-NOTFOUND")
    if("${JAVA_AWT_INCLUDE_PATH}" STREQUAL "JAVA_AWT_INCLUDE_PATH-NOTFOUND")
      set(JAVA_AWT_INCLUDE_PATH "${JAVA_INCLUDE_PATH}")
    endif("${JAVA_AWT_INCLUDE_PATH}" STREQUAL "JAVA_AWT_INCLUDE_PATH-NOTFOUND")
    mark_as_advanced(CLEAR JAVA_INCLUDE_PATH2 JAVA_AWT_INCLUDE_PATH)
ENDIF ( ENABLE_JAVA_SUPPORT )
#  JNI_INCLUDE_DIRS      = the include dirs to use
#  JNI_LIBRARIES         = the libraries to use
#  JNI_FOUND             = TRUE if JNI headers and libraries were found.
#  JAVA_AWT_LIBRARY      = the path to the jawt library
#  JAVA_JVM_LIBRARY      = the path to the jvm library
#  JAVA_INCLUDE_PATH     = the include path to jni.h
#  JAVA_INCLUDE_PATH2    = the include path to jni_md.h
#  JAVA_AWT_INCLUDE_PATH = the include path to jawt.h

IF ( DOJAVA_COMPILE )
IF(DEBUGCMAKE)
  MESSAGE ( STATUS " ===========================================" )
  MESSAGE ( STATUS "  Java" )
  MESSAGE ( STATUS " ===========================================" )
ENDIF(DEBUGCMAKE)
  ## =========================================================================
  ##  Get Java version...
  ## =========================================================================
  EXECUTE_PROCESS ( COMMAND ${JAVA_RUNTIME} -version
                    OUTPUT_VARIABLE JAVA_OUTPUT
                    ERROR_VARIABLE  JAVA_ERROR_OUTPUT
                    RESULT_VARIABLE JAVA_RETURN_VALUE )
  IF ( NOT JAVA_RETURN_VALUE )
    STRING ( REGEX MATCH [0-9._]+ JAVA_VERSION "${JAVA_ERROR_OUTPUT}" )
  ENDIF ( NOT JAVA_RETURN_VALUE )

  GET_FILENAME_COMPONENT (JAVA_BIN_PATH "${JAVA_COMPILE}" PATH)
  FIND_PROGRAM ( JAVA_JAVA_H javah PATHS ${JAVA_BIN_PATH} )
IF(DEBUGCMAKE)
  MESSAGE ( STATUS "  JAVA_VERSION:           " ${JAVA_VERSION} )
  MESSAGE ( STATUS "  JAVA_RUNTIME:           " ${JAVA_RUNTIME} )
  MESSAGE ( STATUS "  JAVA_COMPILE:           " ${JAVA_COMPILE} )
  MESSAGE ( STATUS "  JAVA_ARCHIVE:           " ${JAVA_ARCHIVE} )
  MESSAGE ( STATUS "  JAVA_JAVA_H:            " ${JAVA_JAVA_H} )
  MESSAGE ( STATUS "  JAVA_INCLUDE_PATH:      " ${JAVA_INCLUDE_PATH} )
  MESSAGE ( STATUS "  JAVA_INCLUDE_PATH2:     " ${JAVA_INCLUDE_PATH2} )
  MESSAGE ( STATUS "  JAVA_JVM_LIBRARY:       " ${JAVA_JVM_LIBRARY} )
ENDIF(DEBUGCMAKE)
  SET ( PKG_SUPPORT_JAVA 1 )
ENDIF ( DOJAVA_COMPILE )
IF ( WIN32 )
ELSE ( WIN32 )
ENDIF ( WIN32 )
#ADD_CUSTOM_TARGET ( tcljava.jar.classes
#    COMMAND ${JAVA_COMPILE} -d ${CMAKE_CURRENT_BINARY_DIR}
#            -classpath ${tcljava_CLASSPATH} ${TCLJAVA_JAR_SRCS}
#    WORKING_DIRECTORY src/tcljava )
#ADD_CUSTOM_TARGET ( tcljava.jar
#    COMMAND ${JAVA_ARCHIVE} cvf ${CMAKE_CURRENT_BINARY_DIR}/tcljava.jar
#            tcl
#    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR} )
#ADD_DEPENDENCIES ( tcljava.jar tcljava.jar.classes )

IF ( ENABLE_JAVA_SUPPORT )
include_directories("${JAVA_INCLUDE_PATH}" "${JAVA_INCLUDE_PATH2}")
ENDIF ( ENABLE_JAVA_SUPPORT )
set(JAVA_CMAKE_DONE true)
endif (NOT JAVA_CMAKE_DONE)
